define('aim/absence/view/AbsenceValueView',['aim/util/Utils',
                                            'aim/absence/view/SelectResourceView',
                                            'aim/absence/view/SelectFromView',
                                            'aim/absence/view/SelectToView',
                                            'aim/absence/view/ExtendFilterView'
                                            ], function(
                                            		Utils,
                                            		SelectResourceView,
                                            		SelectFromView,
                                            		SelectToView,
                                            		ExtendFilterView) {
	var AbsenceValueView = Backbone.View.extend({
		
		el : '#add-absence-dialog',
		
		events: {
			"change #resource-single-select" : "resourceSelectChanged",
			"change #fromDate" : "fromChanged",
			"change #toDate" : "toChanged",
			"change #absenceValue" : "absenceValueChanged",
			"click #absencevalues-save-button" : "saveAbsenceValues",
			"click #absencevalues-cancel-button" : "cancelAbsenceValues"
		},
		
		initialize : function() {
			this.listenTo(this.model, 'sync', this.render);
			var selectResourceView = new SelectResourceView({model: this.model});
			var selectedFromDate = new SelectFromView({model: this.model});
			var selectedToDate = new SelectToView({model: this.model});
			var extendFilterView = new ExtendFilterView({model: this.model});
			this.fieldsInError = new Array();
		},
		
		render : function() {
			AJS.$("#absenceValue").attr("value", this.model.get('absenceValue'));
			if( ! this.model.attributes.errorMessage && ! this.model.attributes.warnMessage && ! this.model.attributes.infoMessage){
				Utils.clearMessageBar('#add-dialog-message-bar');
				Utils.clearFieldMarker(this.fieldsInError);
			}
			return this;		
		},
		
		saveAbsenceValues : function() {
			if(this.model.get('selectedResource') == 0 || this.model.attributes.errorMessage )
				return this;
			var that = this;
			this.model.set('saved', "true");
			this.model.set('operation', "spreadInPeriod");

			this.model.save(null, {success:function(model, res, options) {
//				that.options.contextModel.attributes.selectedFilter = 
				that.options.contextModel.set('operation','refresh');
				that.options.contextModel.save();
				var title= AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.message.saved.value.title");
				var replacements = {'%USER%': model.attributes.changedResource.displayName, '%FROM%': model.attributes.from,'%TO%': model.attributes.to };
				var text = AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.message.saved.value.message");
				var message = Utils.replace(replacements,text);
				var flag = Utils.sendMessage('success',title,'auto',message);
				Utils.validateFlagModel(model,'naomi.templates.js.jirarp.board.message');
			},error:function(model, res, options) {
				var title= AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.message.error.value.title");
				var text = AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.message.error.value.message");
				var responseMessage = jQuery.parseJSON(res.responseText);
				var replacements = {'%RESPONSE_MESSAGE%' : responseMessage.message};
				var message = Utils.replace(replacements,text);
				Utils.sendMessage('error',title,'manual',message);
			}});	
			AJS.dialog2("#add-absence-dialog").hide();
		},

		cancelAbsenceValues : function() {
			AJS.dialog2("#add-absence-dialog").hide();
		},
		
		fromChanged : function(event) {
			var absenceValueModel = this.model;
			var value = event.currentTarget.value;
			var fieldHolder = this.fieldsInError;
			var selector = '#'+event.currentTarget.id;
			absenceValueModel.set('from', value);
			absenceValueModel.set('selectedFromChanged', "true");
			absenceValueModel.save(null, {success:function(model, res, options) {
				Utils.validateBarModel(model, 'naomi.templates.js.jirarp.board.message', '#add-dialog-message-bar', selector, fieldHolder);
			},error:function(model, res, options) {
				var responseMessage = jQuery.parseJSON(res.responseText);
				var title= AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.message.error.from.change.title");
				var text = AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.message.error.from.change.message");
				var replacements = {'%RESPONSE_MESSAGE%' : responseMessage.message};
				var message = Utils.replace(replacements,text);
				Utils.sendBarErrorMessage('#add-dialog-message-bar', title, message, false, 5000, 500);
				Utils.markFieldWithError(selector, fieldHolder);
			}});
		},
		
		toChanged : function(event) {
			var absenceValueModel = this.model;
			var value = event.currentTarget.value;
			var fieldHolder = this.fieldsInError;
			var selector = '#'+event.currentTarget.id;
			absenceValueModel.set('to', value);
			absenceValueModel.set('selectedToChanged', "true");
			absenceValueModel.save(null, {success:function(model, res, options) {
				Utils.validateBarModel(model, 'naomi.templates.js.jirarp.board.message', '#add-dialog-message-bar', selector, fieldHolder);
			},error:function(model, res, options) {
				var responseMessage = jQuery.parseJSON(res.responseText);
				var title= AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.message.error.to.change.title");
				var text = AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.message.error.to.change.message");
				var replacements = {'%RESPONSE_MESSAGE%' : responseMessage.message};
				var message = Utils.replace(replacements,text);
				Utils.sendBarErrorMessage('#add-dialog-message-bar', title, message, false, 5000, 500);
				Utils.markFieldWithError(selector, fieldHolder);
			}});
		},
		
		absenceValueChanged : function(event) {
			var absenceValueModel = this.model;
			var value = event.currentTarget.value;
			var fieldHolder = this.fieldsInError;
			var selector = '#'+event.currentTarget.id;
			absenceValueModel.set('absenceValue', value);
			absenceValueModel.set('operation', "validateAbsenceValue");
			absenceValueModel.save(null, {success:function(model, res, options) {
				Utils.validateBarModel(model, 'naomi.templates.js.jirarp.board.message', '#add-dialog-message-bar', selector, fieldHolder);
			},error:function(model, res, options) {
				var responseMessage = jQuery.parseJSON(res.responseText);
				var title= AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.message.error.absence.value.change.title");
				var text = AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.message.error.absence.value.change.message");
				var replacements = {'%RESPONSE_MESSAGE%' : responseMessage.message};
				var message = Utils.replace(replacements,text);
				Utils.sendBarErrorMessage('#add-dialog-message-bar', title, message, false, 5000, 500);
				Utils.markFieldWithError(selector, fieldHolder);
			}});
		},
		
		resourceSelectChanged : function(event) {
			var value = event.currentTarget.value;
//			var changedResource = event.added.name;
			var fieldHolder = this.fieldsInError;
			var selector = '#'+event.currentTarget.id;
//			this.model.set('changedResource', changedResource);
			this.model.set('selectedResource', value);	
			this.model.set('selectedResourceChanged', "true");
			this.model.save(null, {success:function(model, res, options) {
				Utils.validateBarModel(model, 'naomi.templates.js.jirarp.board.message', '#add-dialog-message-bar', selector, fieldHolder);
			},error:function(model, res, options) {
				var responseMessage = jQuery.parseJSON(res.responseText);
				var title= AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.message.error.resource.change.title");
				var text = AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.message.error.resource.change.message");
				var replacements = {'%RESPONSE_MESSAGE%' : responseMessage.message};
				var message = Utils.replace(replacements,text);
				Utils.sendBarErrorMessage('#add-dialog-message-bar', title, message, false, 5000, 500);
				Utils.markFieldWithError(selector, fieldHolder);
			}});

		}
	});
	return AbsenceValueView;
});