define('aim/absence/view/FilterPopupFooterView',['aim/util/Utils','aim/absence/model/CheckFilterNameModel'], function(Utils,CheckFilterNameModel) {
	var FilterPopupFooterView = Backbone.View.extend({
		el: '#filter-popup-footer',

		events: {
			"keyup #filterName": "changeFilterName",
		},
		
		initialize : function() {
			var newFilterModel = this.model;
			var tmpOps = {};
			this.listenTo(newFilterModel, 'sync', this.render);
			if(newFilterModel.get("filterId") != 0){
				tmpOps.edit="edit";
			}
			this.$el.html(Naomi.Templates.JiraRp.filterPopupFooter(tmpOps, null, null));
			this.fieldsInError = new Array();
			return this;
		},
			
		render : function() {
			var newFilterModel = this.model;
			AJS.$("#filterName").val(newFilterModel.get("changedFilterName"));
			if( ! this.model.attributes.errorMessage && ! this.model.attributes.warnMessage && ! this.model.attributes.infoMessage){
				Utils.clearMessageBar('#filter-dialog-message-bar');
				Utils.clearFieldMarker(this.fieldsInError);
			}
			return this;
		},
		
		changeFilterName : function(event) {
			var modelForSave = new CheckFilterNameModel();
			modelForSave.set('filterName', this.model.attributes.filterName);
			modelForSave.set('changedFilterName', event.currentTarget.value);
			modelForSave.set('operation', 'checkFilterName');
			var fieldHolder = this.fieldsInError;
			var selector = '#'+event.currentTarget.id;
			var that=this;
			modelForSave.save(null, {success:function(model, res, options) {
				Utils.validateBarModel(model, 'naomi.templates.js.jirarp.board.message', '#filter-dialog-message-bar', selector, fieldHolder);
				that.model.attributes.errorMessage = model.attributes.errorMessage;
				that.model.attributes.changedFilterName = event.currentTarget.value;
			},error:function(model, res, options) {
				var responseMessage = jQuery.parseJSON(res.responseText);
				var title= AJS.I18n.getText("naomi.templates.js.jirarp.filter.dialog.message.error.save.filtername.title");
				var text = AJS.I18n.getText("naomi.templates.js.jirarp.filter.dialog.message.error.save.filtername.message");
				Utils.sendBarErrorMessage('#filter-dialog-message-bar', title, text, false, 5000, 500);
				Utils.markFieldWithError(selector, fieldHolder);
			}});
		}
		});
	return FilterPopupFooterView;
});