define('aim/admin/view/ExportAbsenceLogView',['aim/admin/model/AuthorAbsenceModel',
                                               'aim/admin/model/ResourceAbsenceModel',
                                               'aim/admin/model/QueryAbsenceLogModel',
                                               'aim/admin/view/SelectResourceView',
                                               'aim/admin/view/SelectAuthorView',
                                               'aim/admin/view/SelectFromView',
                                               'aim/admin/view/SelectToView'], function(
                                            		   AuthorAbsenceModel,
                                            		   ResourceAbsenceModel,
                                            		   QueryAbsenceLogModel,
                                            		   SelectResourceView,
                                            		   SelectAuthorView,
                                            		   SelectFromView,
                                            		   SelectToView) {
	
	
	var ExportAbsenceLogView = Backbone.View.extend({
		
		initialize : function() {
			if(this.queryCapacityLogModel == null)
				this.queryAbsenceLogModel = new QueryAbsenceLogModel();
			this.authorModel = new AuthorAbsenceModel(this.queryAbsenceLogModel);
			this.resourceModel = new ResourceAbsenceModel(this.queryAbsenceLogModel);
			this.selectAuthorView = new SelectAuthorView({el: ExportAbsenceLogView.selectAuthorEl, model: this.authorModel},{options: this.queryAbsenceLogModel});
			this.selectResourceView = new SelectResourceView({el: ExportAbsenceLogView.selectResourceEl, model: this.resourceModel},{options: this.queryAbsenceLogModel});
			this.selectedFromDate = new SelectFromView({el: ExportAbsenceLogView.selectChangeDateEl, model: this.queryAbsenceLogModel});
		},
		
		el : '#export-absence-dialog',
		
		events: {
			'change #select-absence-resource'     : "resourceSelectChanged",
			"change #select-absence-author"       : "authorSelectChanged",
			"change #change-absence-date"         : "fromChanged",
			"click #export-absence-save-button"   : "saveExportValues",
			"click #export-absence-cancel-button" : "cancelExportValues"
		},
		
		render : function() {
			AJS.$(ExportAbsenceLogView.selectChangeDateEl).val('');

			this.authorModel.from = this.queryAbsenceLogModel.from;
			this.authorModel.selectedResource = this.queryAbsenceLogModel.selectedResource;
			this.authorModel.author = this.queryAbsenceLogModel.author;
			this.authorModel.save();
			
			this.authorModel.from = this.queryAbsenceLogModel.from;
			this.resourceModel.selectedResource = this.queryAbsenceLogModel.selectedResource;
			this.authorModel.author = this.queryAbsenceLogModel.author;
			this.resourceModel.save();
			
			this.selectedFromDate.render();
			return this;		
		},
		
		resourceSelectChanged : function(event) {
			var value = event.currentTarget.value;
			this.queryAbsenceLogModel.set('selectedResource', value);
		},

		authorSelectChanged : function(event) {
			var value = event.currentTarget.value;
			this.queryAbsenceLogModel.set('author', value);
		},

		fromChanged : function(event) {
			var value = event.currentTarget.value;
			this.queryAbsenceLogModel.set('from', value);
		},
		
		cancelExportValues : function() {
			AJS.dialog2("#export-absence-dialog").hide();
		},

		saveExportValues : function() {
			var author = this.queryAbsenceLogModel.get('author') == null ? -1 : this.queryAbsenceLogModel.get('author');
			var selectedResource = this.queryAbsenceLogModel.get('selectedResource') == null ? -1 : this.queryAbsenceLogModel.get('selectedResource');
			var pickedDate = this.queryAbsenceLogModel.get('from') == null ? -1 : new Date(this.queryAbsenceLogModel.get('from')).getTime();
			if(isNaN(pickedDate))
				pickedDate = -1;
			var popup=window.open(AJS.contextPath() + '/rest/resources/1.0/log/absenceLog/'+author+'/'+selectedResource+'/'+pickedDate);
			AJS.dialog2("#export-absence-dialog").hide();
		}
		
	},
	{//constants
		selectAuthorEl : '#select-absence-author',
		selectResourceEl : '#select-absence-resource',
		selectChangeDateEl : '#change-absence-date'
	});
	return ExportAbsenceLogView;
});